<?php

class ProductgroupModel {
  public $name = null;
  public $description = null;
  
  public $note = null;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  

  public static function create(Array $data) {
    $model = new Productgroup();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model ->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();

    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("Productgroup", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Productgroup($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("Productgroup", "*", "1 = 1 ORDER BY name");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[$data->id] = new Productgroup($data);
      }
    }
    return $items;
    
  }
  
  public static function getFirst() {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("Productgroup", "*", "$where ORDER BY name");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Productgroup($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("Productgroup", "*", "$where ORDER BY name");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[$data->id] = new Productgroup($data);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";
    
    $db = FronkDB::singleton();

    //var_dump($filter);exit;
    if(array_key_exists("name", $filter)) {
      $name = $db->escape($filter['name']);
      if($name) {
        $where .= " AND `name` like '$name'";
      }
    }
    
    if(array_key_exists("nameLike", $filter)) {
      $name = $db->escape($filter['nameLike']);
      if($name) {
        $where .= " AND `name` like '%$name%'";
      }
    }
    
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}